/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 * @author obper
 */
@Entity
@Table(name = "depto_municipio")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "DeptoMunicipio.findAll", query = "SELECT d FROM DeptoMunicipio d"),
        @NamedQuery(name = "DeptoMunicipio.findByDeptoMunicipioCodigo", query = "SELECT d FROM DeptoMunicipio d WHERE d.deptoMunicipioCodigo = :deptoMunicipioCodigo"),
        @NamedQuery(name = "DeptoMunicipio.findByDeptoMunicipioDepartamento", query = "SELECT d FROM DeptoMunicipio d WHERE d.deptoMunicipioDepartamento = :deptoMunicipioDepartamento"),
        @NamedQuery(name = "DeptoMunicipio.findByDeptoMunicipioNombre", query = "SELECT d FROM DeptoMunicipio d WHERE d.deptoMunicipioNombre = :deptoMunicipioNombre")})
public class DeptoMunicipio implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 4)
    @Column(name = "depto_municipio_codigo")
    private String deptoMunicipioCodigo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 20)
    @Column(name = "depto_municipio_departamento")
    private String deptoMunicipioDepartamento;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 25)
    @Column(name = "depto_municipio_nombre")
    private String deptoMunicipioNombre;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "municipioCodigo")
    private Collection<Consultores> consultoresCollection;

    public DeptoMunicipio() {
    }

    public DeptoMunicipio(String deptoMunicipioCodigo) {
        this.deptoMunicipioCodigo = deptoMunicipioCodigo;
    }

    public DeptoMunicipio(String deptoMunicipioCodigo, String deptoMunicipioDepartamento, String deptoMunicipioNombre) {
        this.deptoMunicipioCodigo = deptoMunicipioCodigo;
        this.deptoMunicipioDepartamento = deptoMunicipioDepartamento;
        this.deptoMunicipioNombre = deptoMunicipioNombre;
    }

    public String getDeptoMunicipioCodigo() {
        return deptoMunicipioCodigo;
    }

    public void setDeptoMunicipioCodigo(String deptoMunicipioCodigo) {
        this.deptoMunicipioCodigo = deptoMunicipioCodigo;
    }

    public String getDeptoMunicipioDepartamento() {
        return deptoMunicipioDepartamento;
    }

    public void setDeptoMunicipioDepartamento(String deptoMunicipioDepartamento) {
        this.deptoMunicipioDepartamento = deptoMunicipioDepartamento;
    }

    public String getDeptoMunicipioNombre() {
        return deptoMunicipioNombre;
    }

    public void setDeptoMunicipioNombre(String deptoMunicipioNombre) {
        this.deptoMunicipioNombre = deptoMunicipioNombre;
    }

    @XmlTransient
    public Collection<Consultores> getConsultoresCollection() {
        return consultoresCollection;
    }

    public void setConsultoresCollection(Collection<Consultores> consultoresCollection) {
        this.consultoresCollection = consultoresCollection;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (deptoMunicipioCodigo != null ? deptoMunicipioCodigo.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DeptoMunicipio)) {
            return false;
        }
        DeptoMunicipio other = (DeptoMunicipio) object;
        if ((this.deptoMunicipioCodigo == null && other.deptoMunicipioCodigo != null) || (this.deptoMunicipioCodigo != null && !this.deptoMunicipioCodigo.equals(other.deptoMunicipioCodigo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.DeptoMunicipio[ deptoMunicipioCodigo=" + deptoMunicipioCodigo + " ]";
    }

}
